/* 1710, Wed 11 Sep 02

   SEND_INFO.C:  Test program for NeTraMet's USER_INFO

   Copyright (C) 2002 by Nevil Brownlee,
   CAIDA | University of Auckland

   gcc -o send_info send_info.c */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/utsname.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


char pkt_skel_hex[] = 
   "30 82 00 54  02 01 01 04  08 4D 6F 62  79 44 69 63  "
   "6B A3 82 00  43 02 04 27  50 26 0D 02  01 00 02 01  "
   "00 30 82 00  33 30 82 00  2F 06 09 2B  06 01 02 01  "
   "28 01 0A 00  04 22 01 00  41 42 43 44  45 46 47 48  "
   "49 4A 4B 4C  4D 4E 4F 50  61 62 63 64  65 66 67 68  "
   "69 6A 6B 6C  6D 6E 6F 70";

/* Data goes from index 54 t0 87 */

#define PKT_SZ   88
#define DATA_IX  54

unsigned char pkt_skel[PKT_SZ];


#define SZ_IFNAME  64
int sd;  /* Target socket */
struct sockaddr_in to;
char to_host[SZ_IFNAME], to_port[SZ_IFNAME];
int pkts = 1;

void test(void);

int main(int argc, char *argv[])
{
   int arg,c;  char *ap;
   struct utsname name;
   struct hostent *hp;
   int j, v;  char *skp;

   to_host[0] = to_port[0] = '\0';
   for (c = 0, arg = 1; arg < argc; ++arg) {
      if (argv[arg][0] == '-') {
         ap = argv[arg]+2;
	 switch (argv[arg][1]) {
	 case 'p':
	   if (*ap == '\0') ap = argv[++arg];  /* 'to' Port nbr */
            strncpy(to_port,ap,SZ_IFNAME);
            break;
	 case 't':
	   if (*ap == '\0') ap = argv[++arg];  /* 'To' host */
            strncpy(to_host,ap,SZ_IFNAME);
            break;
	 default:
	    printf("Invalid option: -%c\n", argv[arg][1]);
	    exit(0);
	    }
	 }
      }

   /* Set up connection to target host */
   if (to_host[0] == '\0') {
      printf("No target host specified <<<\n");
      exit(-2);
      }
   hp = gethostbyname(to_host);
   if (hp == NULL) {
      printf("Unknown host %s <<<\n", to_host);	
      exit(-3);
      }
   to.sin_family = AF_INET;
   memcpy((char *)&to.sin_addr.s_addr, hp->h_addr, hp->h_length);

   to.sin_port = htons(to_port[0] == '\0' ? 9996 : atoi(to_port));

   sd = socket(AF_INET, SOCK_DGRAM, 0);
   if (sd < 0){
      perror("socket");
      exit(1);
      }
   if (connect(sd, (struct sockaddr *)&to, sizeof(to)) != 0) {
      perror("connect");
      exit(2);
      }

   uname(&name);
   printf("Running on %s\n", name.nodename);

   skp = pkt_skel_hex;
   for (j = 0; j != PKT_SZ; ++j) {
     /*   for (j = 0; j != DATA_IX; ++j) { */
      while (*skp == ' ') ++skp;
      c = *skp++;
      v = c > '9' ? c-'A'+10 : c-'0';
      c = *skp++;
      pkt_skel[j] = v << 4 | (c > '9' ? c-'A'+10 : c-'0');
      }
   memset(&pkt_skel[DATA_IX], 0, PKT_SZ-DATA_IX); /**/

   /*   for (j = 0; j != PKT_SZ; ++j)
     printf(" %02x", pkt_skel[j]);
   printf("\n"); */

   test();
   }

#define IP6_ADDR_LEN  16

struct ui_data {
   unsigned char Operation;  /* Start/Stop metering */
   unsigned char UserCoS;
   unsigned char key_val[IP6_ADDR_LEN];
   unsigned char UserID[IP6_ADDR_LEN];
   };

# define UI_LOOKUP  0  /* Actions for UserInfoHelper() */
# define UI_START   1
# define UI_STOP    2

union ui_row {
   struct ui_data d;
   unsigned char ui_bytes[sizeof(struct ui_data)];
   };

void test(void)
{
   union ui_row ui;
   char buf[30], *bp;
   int c;

   memset(ui.ui_bytes, 0, sizeof(struct ui_data));

   for (;;) {
      printf("Operation (%d): ", ui.d.Operation);
      fgets(buf, sizeof(buf), stdin);
      if (buf[0] != '\n') {
         c = buf[0] - '0';
         ui.d.Operation = c;
         }

      printf("key (%s): ", ui.d.key_val);
      fgets(buf, sizeof(buf), stdin);
      if (buf[0] != '\n') {
         memset(ui.d.key_val, 0, sizeof(ui.d.key_val));
         for (c = 1; buf[c] != '\n'; ++c);
         memcpy(ui.d.key_val, buf, c);
         }

      printf("UserID (%s): ", ui.d.UserID);
      fgets(buf, sizeof(buf), stdin);
      if (buf[0] != '\n') {
         memset(ui.d.UserID, 0, sizeof(ui.d.UserID));
         for (c = 1; buf[c] != '\n'; ++c);
         memcpy(ui.d.UserID, buf, c);
         }

      memcpy(&pkt_skel[DATA_IX], ui.ui_bytes, sizeof(struct ui_data));
      sendto(sd, pkt_skel, PKT_SZ, 0,
         (struct sockaddr *)&to, sizeof(to));
      }
   }
